Subiject: Accessing a not present property/method should error verbosely

Description

in my case, | erroneously wrote

page.body.title = ${context.attr('title")}

which resulted in
1<!-- Exception while rendering page&lt;TYPO3.TYPO3:Page&gt;/body :
2Catchable Fatal Error: Object of class TYPO3\Eel\FlowQuery\FlowQuery
3could not be converted to string in /var/www/Data/Temporary/Developmentl
4/Cache/Code/Fluid_TemplateCache/Standalone_template_file_Site_5d5f8dc750
5b9c07fb770fba32529975b68fe55¢41.php line 1193 -->

Christian perfectly summarized it to

yep, so the parser correctly detects the FlowQuery and creates the FlowQuery object but it seems it isn't evaluated

He also provided the reason: there is no "attr’, it must be “property’.
So please provide a better exception catch for such cases. | filed this as Bug because | think it's pretty important for users.

Associated revisions

Revision a12eb1b0 - 2012-08-08 12:09 - Christopher Hlubek
[BUGFIX] Throw an exception when calling undefined method on object
Add tests to the evaluator test case for undefined methods and

function calls on NULL values. Introduce an EvaluationException for
better exception handling (needs further work).

Change-Id: 1e0579ae84b32a64c7103ed458cc0349fac8e94a3

Related: #38459

History

#1 - 2012-08-07 16:55 - Christopher Hlubek
- Assigned To set to Sebastian Kurfuerst
| think this is due to the behaviour in FLowQuery::__call where a unknown operation should rather throw an exception instead of returning the

FlowQuery object itself.

#2 - 2012-08-07 17:06 - Christopher Hlubek

But when adding some more Unit Tests to Context | found some cases where also Eel itself did not throw an exception but returned NULL. Nesting
expressions like foo.bar.baz should be safe in Eel by design, even if NULL values are in the path. But | think if the callee is a method or array there

should be an exception. If the callee is NULL | would return NULL to make chaining safer.
